package Patch;

$patch_dir = "/etc/lefthand/patches";

my @patch_files = ( );   # initialization of patch files

sub get_patch_filename($$) 
{
	my ($pkg_name, $patch_num) = @_;

	my $patch_filename = $patch_dir."/".$patch_num.".xml";

	return $patch_filename;
}

sub get_description($) 
{
	my ($pkg_name, $patch_num) = @_;

    $patch_file = get_patch_filename($pkg_name, $patch_num);
	open( XMLFILE, "<$patch_file") || die "Couldn't open file: $patch_file\n";

	$in_desc = 0;
	my $desc = "";
	while(<XMLFILE>)
	{
        if(/<DESCRIPTION>(.*)<\/DESCRIPTION>/) 
        {
            $desc = $1."\n";
			return $desc;
        }
        elsif(/<DESCRIPTION>(.*)$/) 
		{
			$desc = $1."\n";	
			$in_desc = 1;
		}
		elsif($in_desc == 1)
		{
			if(/^(.*)<\/DESCRIPTION>/)
			{
				$desc = $desc.$1;
				return $desc;
			}
			else
			{
				$desc = $desc.$_;
			}
		}
	}
	return "";
}

sub exists() 
{
	my ($pkg_name, $patch_num_check) = @_;
	@patch_files = get_patchfiles();

	# read each xml file
	foreach $file(@patch_files)
	{
		$xmlfile = "$patch_dir/$file";
		$patch_num = get_number($pkg_name, $xmlfile);
		if ($patch_num eq $patch_num_check)
		{
			return 1;
		}
	}

	return 0;
}

sub get_number() 
{
	my ($pkg_name, $xml_file) = @_;
	
	open( XMLFILE, "<$xml_file") || die "Couldn't open file: $xml_file\n"; 
	while(<XMLFILE>) 
	{
		if( /<PATCH_NUMBER>(\w+-\w+)<\/PATCH_NUMBER>/ ) {
			return $1;
		}
	}

	return 0;

	close(XMLFILE);
}

sub get_installed_date() 
{
	my ($pkg_name, $patch_num) = @_;

	$patch_file = get_patch_filename($pkg_name, $patch_num);
	open( XMLFILE, "<$patch_file") || die "Couldn't open file: $patch_file\n";

	while(<XMLFILE>) 
	{
		if( /<INSTALL_DATE>(.*)<\/INSTALL_DATE>/ ) {
			return $1;
		}
	}

	return 0;

	close(XMLFILE);
}

sub get_patchfiles()
{
    opendir(DIR, $patch_dir) || die "Couldn't open directory: $patch_dir\n";
    @patch_files = grep(/xml$/, readdir(DIR));
    closedir(DIR);
    return @patch_files;
}	

1;

